# -*- coding: utf-8 -*-
##############################################################################
#
#    wms_sale module for OpenERP, Module to extended sale with WMS
#    Copyright (C) 2011 SYLEAM Info Services (<http://www.syleam.fr/>)
#              Jean-Sébastien SUZANNE <jean-sebastien.suzanne@syleam.fr>
#
#    This file is a part of wms_sale
#
#    wms_sale is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    wms_sale is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv
from tools.translate import _


class product_product(osv.osv):
    _inherit = 'product.product'

    def convert_price_in_default_unit(self, cr, uid, id, price, uom_id, context=None):
        """
        :param id : id of the product
        :type id: int
        :param price: the origin price to convert
        :type price: float
        :param uom_id: the unit of the product for this price
        :type uom_id : int
        convert the price in fonction of unit
        - uom_id.category == product.uom_category => price = price * uom_id.factor / product.uom_id.factor
        - uom_id.category == product.uos_category => price = price * product.uos_coeff * uom_id.factor / product.uos_id.factor
        """
        if not id:
            raise osv.except_osv(_('Convert Unit Error'), _('No product defined to convert unit'))
        if not uom_id:
            raise osv.except_osv(_('Convert Unit Error'), _('No UOM defined to convert unit'))
        uom_obj = self.pool.get('product.uom')
        product = self.pool.get('product.product').browse(cr, uid, id, context=context)
        uom = uom_obj.browse(cr, uid, uom_id, context=context)
        if product.uos_id and product.uos_id.category_id.id == uom.category_id.id:
            return uom_obj._compute_price(cr, uid, product.uos_id.id, price * product.uos_coeff or 1.0, product.uom_id.id)
        elif product.uom_id.category_id.id == uom.category_id.id:
            return uom_obj._compute_price(cr, uid, uom_id, price, product.uom_id.id)

product_product()


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
